/*
 *   IBM Omni driver
 *   Copyright (c) International Business Machines Corp., 2001
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License
 *   along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#include <stdio.h>
#include <stdlib.h>

#include <cups/cups.h>
#include <cups/raster.h>

#include <glib.h>
#include <gmodule.h>

#include "Device.hpp"
#include "Omni.hpp"

#define TMM_TO_INCHES 25400.0
#define bufsize 64
#define bufsize1 33

char pszBuffer[bufsize];
char pszBuffer1[bufsize1];

void
outputPostscriptName (DeviceForm *pDF)
{
   HardCopyCap *pHCC = pDF->getHardCopyCap ();
   int          iCx  = (int)(72.0 * (float)pHCC->getCx () / TMM_TO_INCHES);
   int          iCy  = (int)(72.0 * (float)pHCC->getCy () / TMM_TO_INCHES);

   switch (pDF->getID ())
   {
//     case DeviceForm::FORM_LEDGER               : strcpy(pszBuffer,"Ledger")               ; break;
//     case DeviceForm::FORM_LEGAL                : strcpy(pszBuffer,"Legal")                ; break;
//     case DeviceForm::FORM_LEGAL_EXTRA          : strcpy(pszBuffer,"Legal extra")          ; break;
//     case DeviceForm::FORM_LETTER               : strcpy(pszBuffer,"Letter")               ; break;
//     case DeviceForm::FORM_LETTER_PLUS          : strcpy(pszBuffer,"Letter plus")          ; break;
//     case DeviceForm::FORM_LETTER_EXTRA         : strcpy(pszBuffer,"Letter extra")         ; break;
//     case DeviceForm::FORM_HALF_LETTER          : strcpy(pszBuffer,"Half Letter")          ; break;
//     case DeviceForm::FORM_EXECUTIVE            : strcpy(pszBuffer,"Executive")            ; break;
//     case DeviceForm::FORM_STATEMENT            : strcpy(pszBuffer,"Statement")            ; break;
//     case DeviceForm::FORM_TABLOID              : strcpy(pszBuffer,"Tabloid")              ; break;
//     case DeviceForm::FORM_UNIVERSAL            : strcpy(pszBuffer,"Universal")            ; break;
//     case DeviceForm::FORM_FOOLSCAP             : strcpy(pszBuffer,"Foolscap")             ; break;
//     case DeviceForm::FORM_QUARTO               : strcpy(pszBuffer,"Quarto")               ; break;
//     case DeviceForm::FORM_FOLIO                : strcpy(pszBuffer,"Folio")                ; break;
//     case DeviceForm::FORM_FOLIO_SP             : strcpy(pszBuffer,"Folio sp")             ; break;
//     case DeviceForm::FORM_ROC_8K               : strcpy(pszBuffer,"Roc 8K")               ; break;
//     case DeviceForm::FORM_ROC_16K              : strcpy(pszBuffer,"Roc 16K")              ; break;
//     case DeviceForm::FORM_GOVERNMENT_LETTER    : strcpy(pszBuffer,"Government Letter")    ; break;
//     case DeviceForm::FORM_GOVERNMENT_LEGAL     : strcpy(pszBuffer,"Government Legal")     ; break;
//     case DeviceForm::FORM_EDP                  : strcpy(pszBuffer,"EDP")                  ; break;
//     case DeviceForm::FORM_EUROPEAN_EDP         : strcpy(pszBuffer,"European EDP")         ; break;
//     case DeviceForm::FORM_PRC_16K              : strcpy(pszBuffer,"PRC 16K")              ; break;
//     case DeviceForm::FORM_PRC_32K              : strcpy(pszBuffer,"PRC 32K")              ; break;
//     case DeviceForm::FORM_DAI_PA_KAI           : strcpy(pszBuffer,"Dai Pa Kai")           ; break;
// //    case DeviceForm::FORM_JURRO_KU_KAI         : strcpy(pszBuffer,"Jurro Ku Kai")         ; break;
//     case DeviceForm::FORM_PA_KAI               : strcpy(pszBuffer,"Pa Kai")               ; break;
//     case DeviceForm::FORM_WIDE                 : strcpy(pszBuffer,"Wide")                 ; break;
//     case DeviceForm::FORM_LETTER_WIDE          : strcpy(pszBuffer,"Letter Wide")          ; break;
//     case DeviceForm::FORM_FOOLSCAP_WIDE        : strcpy(pszBuffer,"Foolscap Wide")        ; break;
//     case DeviceForm::FORM_A3_WIDE              : strcpy(pszBuffer,"A3 Wide")              ; break;
//     case DeviceForm::FORM_A4_WIDE              : strcpy(pszBuffer,"A4 Wide")              ; break;
//     case DeviceForm::FORM_WIDE_FORMAT          : strcpy(pszBuffer,"Wide Format")          ; break;
//     case DeviceForm::FORM_10_X_11              : strcpy(pszBuffer,"10 x 11")              ; break;
//     case DeviceForm::FORM_11_X_12              : strcpy(pszBuffer,"11 x 12")              ; break;
//     case DeviceForm::FORM_11_X_15              : strcpy(pszBuffer,"11 x 15")              ; break;
//     case DeviceForm::FORM_12_X_19              : strcpy(pszBuffer,"12 x 19")              ; break;
//     case DeviceForm::FORM_15_X_11              : strcpy(pszBuffer,"15 x 11")              ; break;
//     case DeviceForm::FORM_5_X_7                : strcpy(pszBuffer,"5 x 7")                ; break;
//     case DeviceForm::FORM_3_X_5_CARD           : strcpy(pszBuffer,"3 x 5 Card")           ; break;
//     case DeviceForm::FORM_4_X_6_CARD           : strcpy(pszBuffer,"4 x 6 Card")           ; break;
//     case DeviceForm::FORM_5_X_8_CARD           : strcpy(pszBuffer,"5 x 8 Card")           ; break;
//     case DeviceForm::FORM_8_X_10_CARD          : strcpy(pszBuffer,"8 x 10 Card")          ; break;
//     case DeviceForm::FORM_A6_CARD              : strcpy(pszBuffer,"A6 Card")              ; break;
//     case DeviceForm::FORM_CARD_148             : strcpy(pszBuffer,"Card 148")             ; break;
//     case DeviceForm::FORM_HAGAKI_CARD          : strcpy(pszBuffer,"Hagaki Card")          ; break;
//     case DeviceForm::FORM_OUFUKU_CARD          : strcpy(pszBuffer,"Oufuku Card")          ; break;
//     case DeviceForm::FORM_POSTCARD             : strcpy(pszBuffer,"Postcard")             ; break;
//     case DeviceForm::FORM_INDEX_4_X_6_EXT      : strcpy(pszBuffer,"Index 4 x 6 Ext")      ; break;
//     case DeviceForm::FORM_A2_ENVELOPE          : strcpy(pszBuffer,"A2 Envelope")          ; break;
//     case DeviceForm::FORM_C5_ENVELOPE          : strcpy(pszBuffer,"C5 Envelope")          ; break;
//     case DeviceForm::FORM_C6_ENVELOPE          : strcpy(pszBuffer,"C6 Envelope")          ; break;
//     case DeviceForm::FORM_C7_ENVELOPE          : strcpy(pszBuffer,"C7 Envelope")          ; break;
//     case DeviceForm::FORM_C9_ENVELOPE          : strcpy(pszBuffer,"C9 Envelope")          ; break;
//     case DeviceForm::FORM_C10_ENVELOPE         : strcpy(pszBuffer,"C10 Envelope")         ; break;
//     case DeviceForm::FORM_D5_ENVELOPE          : strcpy(pszBuffer,"D5 Envelope")          ; break;
//     case DeviceForm::FORM_DL_ENVELOPE          : strcpy(pszBuffer,"Dl Envelope")          ; break;
//     case DeviceForm::FORM_ENVELOPE_132_X_220   : strcpy(pszBuffer,"Envelope 132 x 220")   ; break;
//     case DeviceForm::FORM_ENVELOPE_6_X_9       : strcpy(pszBuffer,"Envelope 6 x 9")       ; break;
//     case DeviceForm::FORM_ENVELOPE_7_X_9       : strcpy(pszBuffer,"Envelope 7 x 9")       ; break;
//     case DeviceForm::FORM_ENVELOPE_6_1_2       : strcpy(pszBuffer,"Envelope 6 1/2")       ; break;
//     case DeviceForm::FORM_ENVELOPE_9_X_11      : strcpy(pszBuffer,"Envelope 9 x 11")      ; break;
//     case DeviceForm::FORM_ENVELOPE_10_X_13     : strcpy(pszBuffer,"Envelope 10 x 13")     ; break;
//     case DeviceForm::FORM_ENVELOPE_10_X_14     : strcpy(pszBuffer,"Envelope 10 x 14")     ; break;
//     case DeviceForm::FORM_ENVELOPE_10_X_15     : strcpy(pszBuffer,"Envelope 10 x 15")     ; break;
//     case DeviceForm::FORM_MONARCH_ENVELOPE     : strcpy(pszBuffer,"Monarch Envelope")     ; break;
//     case DeviceForm::FORM_PERSONAL_ENVELOPE    : strcpy(pszBuffer,"Personal Envelope")    ; break;
//     case DeviceForm::FORM_NUMBER_9_ENVELOPE    : strcpy(pszBuffer,"Number 9 Envelope")    ; break;
//     case DeviceForm::FORM_NUMBER_10_ENVELOPE   : strcpy(pszBuffer,"Number 10 Envelope")   ; break;
//     case DeviceForm::FORM_NUMBER_11_ENVELOPE   : strcpy(pszBuffer,"Number 11 Envelope")   ; break;
//     case DeviceForm::FORM_NUMBER_12_ENVELOPE   : strcpy(pszBuffer,"Number 12 Envelope")   ; break;
//     case DeviceForm::FORM_NUMBER_14_ENVELOPE   : strcpy(pszBuffer,"Number 14 Envelope")   ; break;
//     case DeviceForm::FORM_ITALIAN_ENVELOPE     : strcpy(pszBuffer,"Italian Envelope")     ; break;
//     case DeviceForm::FORM_POSTFIX_ENVELOPE     : strcpy(pszBuffer,"Postfix Envelope")     ; break;
//     case DeviceForm::FORM_INVITE_ENVELOPE      : strcpy(pszBuffer,"Invite Envelope")      ; break;
//     case DeviceForm::FORM_CHOU2_ENVELOPE       : strcpy(pszBuffer,"Chou2 Envelope")       ; break;
//     case DeviceForm::FORM_CHOU3_ENVELOPE       : strcpy(pszBuffer,"Chou3 Envelope")       ; break;
//     case DeviceForm::FORM_CHOU4_ENVELOPE       : strcpy(pszBuffer,"Chou4 Envelope")       ; break;
//     case DeviceForm::FORM_KAHU_ENVELOPE        : strcpy(pszBuffer,"Kahu Envelope")        ; break;
//     case DeviceForm::FORM_KAKU2_ENVELOPE       : strcpy(pszBuffer,"Kaku2 Envelope")       ; break;
//     case DeviceForm::FORM_YOU4_ENVELOPE        : strcpy(pszBuffer,"You4 Envelope")        ; break;
//     case DeviceForm::FORM_PRC1_ENVELOPE        : strcpy(pszBuffer,"PRC1 Envelope")        ; break;
//     case DeviceForm::FORM_PRC2_ENVELOPE        : strcpy(pszBuffer,"PRC2 Envelope")        ; break;
//     case DeviceForm::FORM_PRC3_ENVELOPE        : strcpy(pszBuffer,"PRC3 Envelope")        ; break;
//     case DeviceForm::FORM_PRC4_ENVELOPE        : strcpy(pszBuffer,"PRC4 Envelope")        ; break;
//     case DeviceForm::FORM_PRC5_ENVELOPE        : strcpy(pszBuffer,"PRC5 Envelope")        ; break;
//     case DeviceForm::FORM_PRC6_ENVELOPE        : strcpy(pszBuffer,"PRC6 Envelope")        ; break;
//     case DeviceForm::FORM_PRC7_ENVELOPE        : strcpy(pszBuffer,"PRC7 Envelope")        ; break;
//     case DeviceForm::FORM_PRC8_ENVELOPE        : strcpy(pszBuffer,"PRC8 Envelope")        ; break;
//     case DeviceForm::FORM_PRC9_ENVELOPE        : strcpy(pszBuffer,"PRC9 Envelope")        ; break;
//     case DeviceForm::FORM_PRC10_ENVELOPE       : strcpy(pszBuffer,"PRC10 Envelope")       ; break;
//     case DeviceForm::FORM_DISK_LABELS          : strcpy(pszBuffer,"Disk Labels")          ; break;
//     case DeviceForm::FORM_EURO_LABELS          : strcpy(pszBuffer,"Euro Labels")          ; break;
//     case DeviceForm::FORM_SHIPPING_LABELS      : strcpy(pszBuffer,"Shipping Labels")      ; break;
//     case DeviceForm::FORM_STANDARD_LABELS_CLEAR: strcpy(pszBuffer,"Standard Labels Clear"); break;
//     case DeviceForm::FORM_STANDARD_LABELS_WHITE: strcpy(pszBuffer,"Standard Labels White"); break;
//     case DeviceForm::FORM_2A0                  : strcpy(pszBuffer,"2A0")                  ; break;
//     case DeviceForm::FORM_4A0                  : strcpy(pszBuffer,"4A0")                  ; break;
//     case DeviceForm::FORM_A0                   : strcpy(pszBuffer,"A0")                   ; break;
//     case DeviceForm::FORM_A1                   : strcpy(pszBuffer,"A1")                   ; break;
//     case DeviceForm::FORM_A2                   : strcpy(pszBuffer,"A2")                   ; break;
//     case DeviceForm::FORM_A3                   : strcpy(pszBuffer,"A3")                   ; break;
//     case DeviceForm::FORM_A3_EXTRA             : strcpy(pszBuffer,"A3 extra")             ; break;
//     case DeviceForm::FORM_A4                   : strcpy(pszBuffer,"A4")                   ; break;
//     case DeviceForm::FORM_A4_EXTRA             : strcpy(pszBuffer,"A4 extra")             ; break;
//     case DeviceForm::FORM_A4_TAB               : strcpy(pszBuffer,"A4 tab")               ; break;
//     case DeviceForm::FORM_A5                   : strcpy(pszBuffer,"A5")                   ; break;
//     case DeviceForm::FORM_A5_EXTRA             : strcpy(pszBuffer,"A5 extra")             ; break;
//     case DeviceForm::FORM_A6                   : strcpy(pszBuffer,"A6")                   ; break;
//     case DeviceForm::FORM_A7                   : strcpy(pszBuffer,"A7")                   ; break;
//     case DeviceForm::FORM_A8                   : strcpy(pszBuffer,"A8")                   ; break;
//     case DeviceForm::FORM_A9                   : strcpy(pszBuffer,"A9")                   ; break;
//     case DeviceForm::FORM_A10                  : strcpy(pszBuffer,"A10")                  ; break;
//     case DeviceForm::FORM_B_PLUS               : strcpy(pszBuffer,"B plus")               ; break;
//     case DeviceForm::FORM_B0                   : strcpy(pszBuffer,"B0")                   ; break;
//     case DeviceForm::FORM_B1                   : strcpy(pszBuffer,"B1")                   ; break;
//     case DeviceForm::FORM_B2                   : strcpy(pszBuffer,"B2")                   ; break;
//     case DeviceForm::FORM_B3                   : strcpy(pszBuffer,"B3")                   ; break;
//     case DeviceForm::FORM_B4                   : strcpy(pszBuffer,"B4 Envelope")          ; break;
//     case DeviceForm::FORM_B5                   : strcpy(pszBuffer,"B5 Envelope")          ; break;
//     case DeviceForm::FORM_B5_EXTRA             : strcpy(pszBuffer,"B5 extra")             ; break;
//     case DeviceForm::FORM_B6                   : strcpy(pszBuffer,"B6 Envelope")          ; break;
//     case DeviceForm::FORM_B6_C4                : strcpy(pszBuffer,"B6/C4 Envelope")       ; break;
//     case DeviceForm::FORM_B7                   : strcpy(pszBuffer,"B7")                   ; break;
//     case DeviceForm::FORM_B8                   : strcpy(pszBuffer,"B8")                   ; break;
//     case DeviceForm::FORM_B9                   : strcpy(pszBuffer,"B9")                   ; break;
//     case DeviceForm::FORM_B10                  : strcpy(pszBuffer,"B10")                  ; break;
//     case DeviceForm::FORM_JIS_B0               : strcpy(pszBuffer,"JIS B0")               ; break;
//     case DeviceForm::FORM_JIS_B1               : strcpy(pszBuffer,"JIS B1")               ; break;
//     case DeviceForm::FORM_JIS_B2               : strcpy(pszBuffer,"JIS B2")               ; break;
//     case DeviceForm::FORM_JIS_B3               : strcpy(pszBuffer,"JIS B3")               ; break;
//     case DeviceForm::FORM_JIS_B4               : strcpy(pszBuffer,"JIS B4")               ; break;
//     case DeviceForm::FORM_JIS_B5               : strcpy(pszBuffer,"JIS B5")               ; break;
//     case DeviceForm::FORM_JIS_B6               : strcpy(pszBuffer,"JIS B6")               ; break;
//     case DeviceForm::FORM_JIS_B7               : strcpy(pszBuffer,"JIS B7")               ; break;
//     case DeviceForm::FORM_JIS_B8               : strcpy(pszBuffer,"JIS B8")               ; break;
//     case DeviceForm::FORM_JIS_B9               : strcpy(pszBuffer,"JIS B9")               ; break;
//     case DeviceForm::FORM_JIS_B10              : strcpy(pszBuffer,"JIS B10")              ; break;
//     case DeviceForm::FORM_JIS_EXEC             : strcpy(pszBuffer,"JIS Exec")             ; break;
//     case DeviceForm::FORM_C0                   : strcpy(pszBuffer,"C0")                   ; break;
//     case DeviceForm::FORM_C1                   : strcpy(pszBuffer,"C1")                   ; break;
//     case DeviceForm::FORM_C2                   : strcpy(pszBuffer,"C2")                   ; break;
//     case DeviceForm::FORM_C3                   : strcpy(pszBuffer,"C3")                   ; break;
//     case DeviceForm::FORM_C4                   : strcpy(pszBuffer,"C4")                   ; break;
//     case DeviceForm::FORM_C5                   : strcpy(pszBuffer,"C5")                   ; break;
//     case DeviceForm::FORM_C6                   : strcpy(pszBuffer,"C6")                   ; break;
//     case DeviceForm::FORM_C6_C5                : strcpy(pszBuffer,"C6/C5")                ; break;
//     case DeviceForm::FORM_C7                   : strcpy(pszBuffer,"C7")                   ; break;
//     case DeviceForm::FORM_C7_C6                : strcpy(pszBuffer,"C7/C6")                ; break;
//     case DeviceForm::FORM_C8                   : strcpy(pszBuffer,"C8")                   ; break;
//     case DeviceForm::FORM_C9                   : strcpy(pszBuffer,"C9")                   ; break;
//     case DeviceForm::FORM_C10                  : strcpy(pszBuffer,"C10")                  ; break;
//     case DeviceForm::FORM_E1                   : strcpy(pszBuffer,"E1")                   ; break;
//     case DeviceForm::FORM_RA0                  : strcpy(pszBuffer,"RA0")                  ; break;
//     case DeviceForm::FORM_RA1                  : strcpy(pszBuffer,"RA1")                  ; break;
//     case DeviceForm::FORM_RA2                  : strcpy(pszBuffer,"RA2")                  ; break;
//     case DeviceForm::FORM_SRA0                 : strcpy(pszBuffer,"SRA0")                 ; break;
//     case DeviceForm::FORM_SRA1                 : strcpy(pszBuffer,"SRA1")                 ; break;
//     case DeviceForm::FORM_SRA2                 : strcpy(pszBuffer,"SRA2")                 ; break;
//     case DeviceForm::FORM_US_FANFOLD           : strcpy(pszBuffer,"Fanfold")              ; break;
//     case DeviceForm::FORM_FANFOLD_1            : strcpy(pszBuffer,"Fanfold #1")           ; break;
//     case DeviceForm::FORM_FANFOLD_2            : strcpy(pszBuffer,"Fanfold #2")           ; break;
//     case DeviceForm::FORM_FANFOLD_3            : strcpy(pszBuffer,"Fanfold #3")           ; break;
//     case DeviceForm::FORM_FANFOLD_4            : strcpy(pszBuffer,"Fanfold #4")           ; break;
//     case DeviceForm::FORM_FANFOLD_5            : strcpy(pszBuffer,"Fanfold #5")           ; break;
//     case DeviceForm::FORM_GERMAN_LEGAL_FANFOLD : strcpy(pszBuffer,"German Legal Fanfold") ; break;
//     case DeviceForm::FORM_EUROPEAN_FANFOLD     : strcpy(pszBuffer,"European Fanfold")     ; break;
//     case DeviceForm::FORM_PANORAMIC            : strcpy(pszBuffer,"Panoramic")            ; break;
//     case DeviceForm::FORM_PHOTO_100_150        : strcpy(pszBuffer,"Photo 100x150")        ; break;
//     case DeviceForm::FORM_PHOTO_200_300        : strcpy(pszBuffer,"Photo 200x300")        ; break;
//     case DeviceForm::FORM_PHOTO_4_6            : strcpy(pszBuffer,"Photo 4x6")            ; break;
//     case DeviceForm::FORM_PLOTTER_SIZE_A       : strcpy(pszBuffer,"Plotter A paper")      ; break;
//     case DeviceForm::FORM_PLOTTER_SIZE_B       : strcpy(pszBuffer,"Plotter B paper")      ; break;
//     case DeviceForm::FORM_PLOTTER_SIZE_C       : strcpy(pszBuffer,"Plotter C paper")      ; break;
//     case DeviceForm::FORM_PLOTTER_SIZE_D       : strcpy(pszBuffer,"Plotter D paper")      ; break;
//     case DeviceForm::FORM_PLOTTER_SIZE_E       : strcpy(pszBuffer,"Plotter E paper")      ; break;
//     case DeviceForm::FORM_PLOTTER_SIZE_F       : strcpy(pszBuffer,"Plotter F paper")      ; break;
//     case DeviceForm::FORM_US_A_ARCHITECTURAL   : strcpy(pszBuffer,"US A Architectural")   ; break;
//     case DeviceForm::FORM_US_B_ARCHITECTURAL   : strcpy(pszBuffer,"US B Architectural")   ; break;
//     case DeviceForm::FORM_US_C_ARCHITECTURAL   : strcpy(pszBuffer,"US C Architectural")   ; break;
//     case DeviceForm::FORM_US_D_ARCHITECTURAL   : strcpy(pszBuffer,"US D Architectural")   ; break;
//     case DeviceForm::FORM_US_E_ARCHITECTURAL   : strcpy(pszBuffer,"US E Architectural")   ; break;
//     case DeviceForm::FORM_SUPER_A3_B           : strcpy(pszBuffer,"Super A3-B")           ; break;
//     case DeviceForm::FORM_SUPER_A              : strcpy(pszBuffer,"Super A")              ; break;
//     case DeviceForm::FORM_SUPER_B              : strcpy(pszBuffer,"Super B")              ; break;
//     case DeviceForm::FORM_ROLL_76_2MM          : strcpy(pszBuffer,"76.2 mm Roll")         ; break;
//     case DeviceForm::FORM_ROLL_69_5MM          : strcpy(pszBuffer,"69.5 mm Roll")         ; break;

       case DeviceForm::FORM_LEDGER               : strcpy(pszBuffer,"FORM_LEDGER"); break;
       case DeviceForm::FORM_LEGAL                : strcpy(pszBuffer,"FORM_LEGAL"); break;
       case DeviceForm::FORM_LEGAL_EXTRA          : strcpy(pszBuffer,"FORM_LEGAL_EXTRA"); break;
       case DeviceForm::FORM_LETTER               : strcpy(pszBuffer,"FORM_LETTER"); break;
       case DeviceForm::FORM_LETTER_PLUS          : strcpy(pszBuffer,"FORM_LETTER_PLUS"); break;
       case DeviceForm::FORM_LETTER_EXTRA         : strcpy(pszBuffer,"FORM_LETTER_EXTRA"); break;
       case DeviceForm::FORM_HALF_LETTER          : strcpy(pszBuffer,"FORM_HALF_LETTER"); break;
       case DeviceForm::FORM_EXECUTIVE            : strcpy(pszBuffer,"FORM_EXECUTIVE"); break;
       case DeviceForm::FORM_STATEMENT            : strcpy(pszBuffer,"FORM_STATEMENT"); break;
       case DeviceForm::FORM_TABLOID              : strcpy(pszBuffer,"FORM_TABLOID"); break;
       case DeviceForm::FORM_UNIVERSAL            : strcpy(pszBuffer,"FORM_UNIVERSAL"); break;
       case DeviceForm::FORM_FOOLSCAP             : strcpy(pszBuffer,"FORM_FOOLSCAP"); break;
       case DeviceForm::FORM_QUARTO               : strcpy(pszBuffer,"FORM_QUARTO"); break;
       case DeviceForm::FORM_FOLIO                : strcpy(pszBuffer,"FORM_FOLIO"); break;
       case DeviceForm::FORM_FOLIO_SP             : strcpy(pszBuffer,"FORM_FOLIO_SP"); break;
       case DeviceForm::FORM_ROC_8K               : strcpy(pszBuffer,"FORM_ROC_8K"); break;
       case DeviceForm::FORM_ROC_16K              : strcpy(pszBuffer,"FORM_ROC_16K"); break;
       case DeviceForm::FORM_GOVERNMENT_LETTER    : strcpy(pszBuffer,"FORM_GOVERNMENT_LETTER"); break;
       case DeviceForm::FORM_GOVERNMENT_LEGAL     : strcpy(pszBuffer,"FORM_GOVERNMENT_LEGAL"); break;
       case DeviceForm::FORM_EDP                  : strcpy(pszBuffer,"FORM_EDP"); break;
       case DeviceForm::FORM_EUROPEAN_EDP         : strcpy(pszBuffer,"FORM_EUROPEAN_EDP"); break;
       case DeviceForm::FORM_PRC_16K              : strcpy(pszBuffer,"FORM_PRC_16K"); break;
       case DeviceForm::FORM_PRC_32K              : strcpy(pszBuffer,"FORM_PRC_32K"); break;
       case DeviceForm::FORM_DAI_PA_KAI           : strcpy(pszBuffer,"FORM_DAI_PA_KAI"); break;
   //    case DeviceForm::FORM_JURRO_KU_KAI         : strcpy(pszBuffe"::FORM_JURRO_KU_KAI       ")  ; break;
       case DeviceForm::FORM_PA_KAI               : strcpy(pszBuffer,"FORM_PA_KAI"); break;
       case DeviceForm::FORM_WIDE                 : strcpy(pszBuffer,"FORM_WIDE"); break;
       case DeviceForm::FORM_LETTER_WIDE          : strcpy(pszBuffer,"FORM_LETTER_WIDE"); break;
       case DeviceForm::FORM_FOOLSCAP_WIDE        : strcpy(pszBuffer,"FORM_FOOLSCAP_WIDE"); break;
       case DeviceForm::FORM_A3_WIDE              : strcpy(pszBuffer,"FORM_A3_WIDE"); break;
       case DeviceForm::FORM_A4_WIDE              : strcpy(pszBuffer,"FORM_A4_WIDE"); break;
       case DeviceForm::FORM_WIDE_FORMAT          : strcpy(pszBuffer,"FORM_WIDE_FORMAT"); break;
       case DeviceForm::FORM_10_X_11              : strcpy(pszBuffer,"FORM_10_X_11"); break;
       case DeviceForm::FORM_11_X_12              : strcpy(pszBuffer,"FORM_11_X_12"); break;
       case DeviceForm::FORM_11_X_15              : strcpy(pszBuffer,"FORM_11_X_15"); break;
       case DeviceForm::FORM_12_X_19              : strcpy(pszBuffer,"FORM_12_X_19"); break;
       case DeviceForm::FORM_15_X_11              : strcpy(pszBuffer,"FORM_15_X_11"); break;
       case DeviceForm::FORM_5_X_7                : strcpy(pszBuffer,"FORM_5_X_7"); break;
       case DeviceForm::FORM_3_X_5_CARD           : strcpy(pszBuffer,"FORM_3_X_5_CARD"); break;
       case DeviceForm::FORM_4_X_6_CARD           : strcpy(pszBuffer,"FORM_4_X_6_CARD"); break;
       case DeviceForm::FORM_5_X_8_CARD           : strcpy(pszBuffer,"FORM_5_X_8_CARD"); break;
       case DeviceForm::FORM_8_X_10_CARD          : strcpy(pszBuffer,"FORM_8_X_10_CARD"); break;
       case DeviceForm::FORM_A6_CARD              : strcpy(pszBuffer,"FORM_A6_CARD"); break;
       case DeviceForm::FORM_CARD_148             : strcpy(pszBuffer,"FORM_CARD_148"); break;
       case DeviceForm::FORM_HAGAKI_CARD          : strcpy(pszBuffer,"FORM_HAGAKI_CARD"); break;
       case DeviceForm::FORM_OUFUKU_CARD          : strcpy(pszBuffer,"FORM_OUFUKU_CARD"); break;
       case DeviceForm::FORM_POSTCARD             : strcpy(pszBuffer,"FORM_POSTCARD"); break;
       case DeviceForm::FORM_INDEX_4_X_6_EXT      : strcpy(pszBuffer,"FORM_INDEX_4_X_6_EXT"); break;
       case DeviceForm::FORM_A2_ENVELOPE          : strcpy(pszBuffer,"FORM_A2_ENVELOPE"); break;
       case DeviceForm::FORM_C5_ENVELOPE          : strcpy(pszBuffer,"FORM_C5_ENVELOPE"); break;
       case DeviceForm::FORM_C6_ENVELOPE          : strcpy(pszBuffer,"FORM_C6_ENVELOPE"); break;
       case DeviceForm::FORM_C7_ENVELOPE          : strcpy(pszBuffer,"FORM_C7_ENVELOPE"); break;
       case DeviceForm::FORM_C9_ENVELOPE          : strcpy(pszBuffer,"FORM_C9_ENVELOPE"); break;
       case DeviceForm::FORM_C10_ENVELOPE         : strcpy(pszBuffer,"FORM_C10_ENVELOPE"); break;
       case DeviceForm::FORM_D5_ENVELOPE          : strcpy(pszBuffer,"FORM_D5_ENVELOPE"); break;
       case DeviceForm::FORM_DL_ENVELOPE          : strcpy(pszBuffer,"FORM_DL_ENVELOPE"); break;
       case DeviceForm::FORM_ENVELOPE_132_X_220   : strcpy(pszBuffer,"FORM_ENVELOPE_132_X_220"); break;
       case DeviceForm::FORM_ENVELOPE_6_X_9       : strcpy(pszBuffer,"FORM_ENVELOPE_6_X_9"); break;
       case DeviceForm::FORM_ENVELOPE_7_X_9       : strcpy(pszBuffer,"FORM_ENVELOPE_7_X_9"); break;
       case DeviceForm::FORM_ENVELOPE_6_1_2       : strcpy(pszBuffer,"FORM_ENVELOPE_6_1_2"); break;
       case DeviceForm::FORM_ENVELOPE_9_X_11      : strcpy(pszBuffer,"FORM_ENVELOPE_9_X_11"); break;
       case DeviceForm::FORM_ENVELOPE_10_X_13     : strcpy(pszBuffer,"FORM_ENVELOPE_10_X_13"); break;
       case DeviceForm::FORM_ENVELOPE_10_X_14     : strcpy(pszBuffer,"FORM_ENVELOPE_10_X_14"); break;
       case DeviceForm::FORM_ENVELOPE_10_X_15     : strcpy(pszBuffer,"FORM_ENVELOPE_10_X_15"); break;
       case DeviceForm::FORM_MONARCH_ENVELOPE     : strcpy(pszBuffer,"FORM_MONARCH_ENVELOPE"); break;
       case DeviceForm::FORM_PERSONAL_ENVELOPE    : strcpy(pszBuffer,"FORM_PERSONAL_ENVELOPE"); break;
       case DeviceForm::FORM_NUMBER_9_ENVELOPE    : strcpy(pszBuffer,"FORM_NUMBER_9_ENVELOPE"); break;
       case DeviceForm::FORM_NUMBER_10_ENVELOPE   : strcpy(pszBuffer,"FORM_NUMBER_10_ENVELOPE"); break;
       case DeviceForm::FORM_NUMBER_11_ENVELOPE   : strcpy(pszBuffer,"FORM_NUMBER_11_ENVELOPE"); break;
       case DeviceForm::FORM_NUMBER_12_ENVELOPE   : strcpy(pszBuffer,"FORM_NUMBER_12_ENVELOPE"); break;
       case DeviceForm::FORM_NUMBER_14_ENVELOPE   : strcpy(pszBuffer,"FORM_NUMBER_14_ENVELOPE"); break;
       case DeviceForm::FORM_ITALIAN_ENVELOPE     : strcpy(pszBuffer,"FORM_ITALIAN_ENVELOPE"); break;
       case DeviceForm::FORM_POSTFIX_ENVELOPE     : strcpy(pszBuffer,"FORM_POSTFIX_ENVELOPE"); break;
       case DeviceForm::FORM_INVITE_ENVELOPE      : strcpy(pszBuffer,"FORM_INVITE_ENVELOPE"); break;
       case DeviceForm::FORM_CHOU2_ENVELOPE       : strcpy(pszBuffer,"FORM_CHOU2_ENVELOPE"); break;
       case DeviceForm::FORM_CHOU3_ENVELOPE       : strcpy(pszBuffer,"FORM_CHOU3_ENVELOPE"); break;
       case DeviceForm::FORM_CHOU4_ENVELOPE       : strcpy(pszBuffer,"FORM_CHOU4_ENVELOPE"); break;
       case DeviceForm::FORM_KAHU_ENVELOPE        : strcpy(pszBuffer,"FORM_KAHU_ENVELOPE"); break;
       case DeviceForm::FORM_KAKU2_ENVELOPE       : strcpy(pszBuffer,"FORM_KAKU2_ENVELOPE"); break;
       case DeviceForm::FORM_YOU4_ENVELOPE        : strcpy(pszBuffer,"FORM_YOU4_ENVELOPE"); break;
       case DeviceForm::FORM_PRC1_ENVELOPE        : strcpy(pszBuffer,"FORM_PRC1_ENVELOPE"); break;
       case DeviceForm::FORM_PRC2_ENVELOPE        : strcpy(pszBuffer,"FORM_PRC2_ENVELOPE"); break;
       case DeviceForm::FORM_PRC3_ENVELOPE        : strcpy(pszBuffer,"FORM_PRC3_ENVELOPE"); break;
       case DeviceForm::FORM_PRC4_ENVELOPE        : strcpy(pszBuffer,"FORM_PRC4_ENVELOPE"); break;
       case DeviceForm::FORM_PRC5_ENVELOPE        : strcpy(pszBuffer,"FORM_PRC5_ENVELOPE"); break;
       case DeviceForm::FORM_PRC6_ENVELOPE        : strcpy(pszBuffer,"FORM_PRC6_ENVELOPE"); break;
       case DeviceForm::FORM_PRC7_ENVELOPE        : strcpy(pszBuffer,"FORM_PRC7_ENVELOPE"); break;
       case DeviceForm::FORM_PRC8_ENVELOPE        : strcpy(pszBuffer,"FORM_PRC8_ENVELOPE"); break;
       case DeviceForm::FORM_PRC9_ENVELOPE        : strcpy(pszBuffer,"FORM_PRC9_ENVELOPE"); break;
       case DeviceForm::FORM_PRC10_ENVELOPE       : strcpy(pszBuffer,"FORM_PRC10_ENVELOPE"); break;
       case DeviceForm::FORM_DISK_LABELS          : strcpy(pszBuffer,"FORM_DISK_LABELS"); break;
       case DeviceForm::FORM_EURO_LABELS          : strcpy(pszBuffer,"FORM_EURO_LABELS"); break;
       case DeviceForm::FORM_SHIPPING_LABELS      : strcpy(pszBuffer,"FORM_SHIPPING_LABELS"); break;
       case DeviceForm::FORM_STANDARD_LABELS_CLEAR: strcpy(pszBuffer,"FORM_STANDARD_LABELS_CLEAR"); break;
       case DeviceForm::FORM_STANDARD_LABELS_WHITE: strcpy(pszBuffer,"FORM_STANDARD_LABELS_WHITE"); break;
       case DeviceForm::FORM_2A0                  : strcpy(pszBuffer,"FORM_2A0"); break;
       case DeviceForm::FORM_4A0                  : strcpy(pszBuffer,"FORM_4A0"); break;
       case DeviceForm::FORM_A0                   : strcpy(pszBuffer,"FORM_A0"); break;
       case DeviceForm::FORM_A1                   : strcpy(pszBuffer,"FORM_A1"); break;
       case DeviceForm::FORM_A2                   : strcpy(pszBuffer,"FORM_A2"); break;
       case DeviceForm::FORM_A3                   : strcpy(pszBuffer,"FORM_A3"); break;
       case DeviceForm::FORM_A3_EXTRA             : strcpy(pszBuffer,"FORM_A3_EXTRA"); break;
       case DeviceForm::FORM_A4                   : strcpy(pszBuffer,"FORM_A4"); break;
       case DeviceForm::FORM_A4_EXTRA             : strcpy(pszBuffer,"FORM_A4_EXTRA"); break;
       case DeviceForm::FORM_A4_TAB               : strcpy(pszBuffer,"FORM_A4_TAB"); break;
       case DeviceForm::FORM_A5                   : strcpy(pszBuffer,"FORM_A5"); break;
       case DeviceForm::FORM_A5_EXTRA             : strcpy(pszBuffer,"FORM_A5_EXTRA"); break;
       case DeviceForm::FORM_A6                   : strcpy(pszBuffer,"FORM_A6"); break;
       case DeviceForm::FORM_A7                   : strcpy(pszBuffer,"FORM_A7"); break;
       case DeviceForm::FORM_A8                   : strcpy(pszBuffer,"FORM_A8"); break;
       case DeviceForm::FORM_A9                   : strcpy(pszBuffer,"FORM_A9"); break;
       case DeviceForm::FORM_A10                  : strcpy(pszBuffer,"FORM_A10"); break;
       case DeviceForm::FORM_B_PLUS               : strcpy(pszBuffer,"FORM_B_PLUS"); break;
       case DeviceForm::FORM_B0                   : strcpy(pszBuffer,"FORM_B0"); break;
       case DeviceForm::FORM_B1                   : strcpy(pszBuffer,"FORM_B1"); break;
       case DeviceForm::FORM_B2                   : strcpy(pszBuffer,"FORM_B2"); break;
       case DeviceForm::FORM_B3                   : strcpy(pszBuffer,"FORM_B3"); break;
       case DeviceForm::FORM_B4                   : strcpy(pszBuffer,"FORM_B4"); break;
       case DeviceForm::FORM_B5                   : strcpy(pszBuffer,"FORM_B5"); break;
       case DeviceForm::FORM_B5_EXTRA             : strcpy(pszBuffer,"FORM_B5_EXTRA"); break;
       case DeviceForm::FORM_B6                   : strcpy(pszBuffer,"FORM_B6"); break;
       case DeviceForm::FORM_B6_C4                : strcpy(pszBuffer,"FORM_B6_C4"); break;
       case DeviceForm::FORM_B7                   : strcpy(pszBuffer,"FORM_B7"); break;
       case DeviceForm::FORM_B8                   : strcpy(pszBuffer,"FORM_B8"); break;
       case DeviceForm::FORM_B9                   : strcpy(pszBuffer,"FORM_B9"); break;
       case DeviceForm::FORM_B10                  : strcpy(pszBuffer,"FORM_B10"); break;
       case DeviceForm::FORM_JIS_B0               : strcpy(pszBuffer,"FORM_JIS_B0"); break;
       case DeviceForm::FORM_JIS_B1               : strcpy(pszBuffer,"FORM_JIS_B1"); break;
       case DeviceForm::FORM_JIS_B2               : strcpy(pszBuffer,"FORM_JIS_B2"); break;
       case DeviceForm::FORM_JIS_B3               : strcpy(pszBuffer,"FORM_JIS_B3"); break;
       case DeviceForm::FORM_JIS_B4               : strcpy(pszBuffer,"FORM_JIS_B4"); break;
       case DeviceForm::FORM_JIS_B5               : strcpy(pszBuffer,"FORM_JIS_B5"); break;
       case DeviceForm::FORM_JIS_B6               : strcpy(pszBuffer,"FORM_JIS_B6"); break;
       case DeviceForm::FORM_JIS_B7               : strcpy(pszBuffer,"FORM_JIS_B7"); break;
       case DeviceForm::FORM_JIS_B8               : strcpy(pszBuffer,"FORM_JIS_B8"); break;
       case DeviceForm::FORM_JIS_B9               : strcpy(pszBuffer,"FORM_JIS_B9"); break;
       case DeviceForm::FORM_JIS_B10              : strcpy(pszBuffer,"FORM_JIS_B10"); break;
       case DeviceForm::FORM_JIS_EXEC             : strcpy(pszBuffer,"FORM_JIS_EXEC"); break;
       case DeviceForm::FORM_C0                   : strcpy(pszBuffer,"FORM_C0"); break;
       case DeviceForm::FORM_C1                   : strcpy(pszBuffer,"FORM_C1"); break;
       case DeviceForm::FORM_C2                   : strcpy(pszBuffer,"FORM_C2"); break;
       case DeviceForm::FORM_C3                   : strcpy(pszBuffer,"FORM_C3"); break;
       case DeviceForm::FORM_C4                   : strcpy(pszBuffer,"FORM_C4"); break;
       case DeviceForm::FORM_C5                   : strcpy(pszBuffer,"FORM_C5"); break;
       case DeviceForm::FORM_C6                   : strcpy(pszBuffer,"FORM_C6"); break;
       case DeviceForm::FORM_C6_C5                : strcpy(pszBuffer,"FORM_C6_C5"); break;
       case DeviceForm::FORM_C7                   : strcpy(pszBuffer,"FORM_C7"); break;
       case DeviceForm::FORM_C7_C6                : strcpy(pszBuffer,"FORM_C7_C6"); break;
       case DeviceForm::FORM_C8                   : strcpy(pszBuffer,"FORM_C8"); break;
       case DeviceForm::FORM_C9                   : strcpy(pszBuffer,"FORM_C9"); break;
       case DeviceForm::FORM_C10                  : strcpy(pszBuffer,"FORM_C10"); break;
       case DeviceForm::FORM_E1                   : strcpy(pszBuffer,"FORM_E1"); break;
       case DeviceForm::FORM_RA0                  : strcpy(pszBuffer,"FORM_RA0"); break;
       case DeviceForm::FORM_RA1                  : strcpy(pszBuffer,"FORM_RA1"); break;
       case DeviceForm::FORM_RA2                  : strcpy(pszBuffer,"FORM_RA2"); break;
       case DeviceForm::FORM_SRA0                 : strcpy(pszBuffer,"FORM_SRA0"); break;
       case DeviceForm::FORM_SRA1                 : strcpy(pszBuffer,"FORM_SRA1"); break;
       case DeviceForm::FORM_SRA2                 : strcpy(pszBuffer,"FORM_SRA2"); break;
       case DeviceForm::FORM_US_FANFOLD           : strcpy(pszBuffer,"FORM_US_FANFOLD"); break;
       case DeviceForm::FORM_FANFOLD_1            : strcpy(pszBuffer,"FORM_FANFOLD_1"); break;
       case DeviceForm::FORM_FANFOLD_2            : strcpy(pszBuffer,"FORM_FANFOLD_2"); break;
       case DeviceForm::FORM_FANFOLD_3            : strcpy(pszBuffer,"FORM_FANFOLD_3"); break;
       case DeviceForm::FORM_FANFOLD_4            : strcpy(pszBuffer,"FORM_FANFOLD_4"); break;
       case DeviceForm::FORM_FANFOLD_5            : strcpy(pszBuffer,"FORM_FANFOLD_5"); break;
       case DeviceForm::FORM_GERMAN_LEGAL_FANFOLD : strcpy(pszBuffer,"FORM_GERMAN_LEGAL_FANFOLD"); break;
       case DeviceForm::FORM_EUROPEAN_FANFOLD     : strcpy(pszBuffer,"FORM_EUROPEAN_FANFOLD"); break;
       case DeviceForm::FORM_PANORAMIC            : strcpy(pszBuffer,"FORM_PANORAMIC"); break;
       case DeviceForm::FORM_PHOTO_100_150        : strcpy(pszBuffer,"FORM_PHOTO_100_150"); break;
       case DeviceForm::FORM_PHOTO_200_300        : strcpy(pszBuffer,"FORM_PHOTO_200_300"); break;
       case DeviceForm::FORM_PHOTO_4_6            : strcpy(pszBuffer,"FORM_PHOTO_4_6"); break;
       case DeviceForm::FORM_PLOTTER_SIZE_A       : strcpy(pszBuffer,"FORM_PLOTTER_SIZE_A"); break;
       case DeviceForm::FORM_PLOTTER_SIZE_B       : strcpy(pszBuffer,"FORM_PLOTTER_SIZE_B"); break;
       case DeviceForm::FORM_PLOTTER_SIZE_C       : strcpy(pszBuffer,"FORM_PLOTTER_SIZE_C"); break;
       case DeviceForm::FORM_PLOTTER_SIZE_D       : strcpy(pszBuffer,"FORM_PLOTTER_SIZE_D"); break;
       case DeviceForm::FORM_PLOTTER_SIZE_E       : strcpy(pszBuffer,"FORM_PLOTTER_SIZE_E"); break;
       case DeviceForm::FORM_PLOTTER_SIZE_F       : strcpy(pszBuffer,"FORM_PLOTTER_SIZE_F"); break;
       case DeviceForm::FORM_US_A_ARCHITECTURAL   : strcpy(pszBuffer,"FORM_US_A_ARCHITECTURAL"); break;
       case DeviceForm::FORM_US_B_ARCHITECTURAL   : strcpy(pszBuffer,"FORM_US_B_ARCHITECTURAL"); break;
       case DeviceForm::FORM_US_C_ARCHITECTURAL   : strcpy(pszBuffer,"FORM_US_C_ARCHITECTURAL"); break;
       case DeviceForm::FORM_US_D_ARCHITECTURAL   : strcpy(pszBuffer,"FORM_US_D_ARCHITECTURAL"); break;
       case DeviceForm::FORM_US_E_ARCHITECTURAL   : strcpy(pszBuffer,"FORM_US_E_ARCHITECTURAL"); break;
       case DeviceForm::FORM_SUPER_A3_B           : strcpy(pszBuffer,"FORM_SUPER_A3_B"); break;
       case DeviceForm::FORM_SUPER_A              : strcpy(pszBuffer,"FORM_SUPER_A"); break;
       case DeviceForm::FORM_SUPER_B              : strcpy(pszBuffer,"FORM_SUPER_B"); break;
       case DeviceForm::FORM_8_5_X_12_4           : strcpy(pszBuffer,"FORM_8_5_X_12_4"); break;
       case DeviceForm::FORM_8_X_10_5             : strcpy(pszBuffer,"FORM_8_X_10_5"); break;
       case DeviceForm::FORM_8_25_X_13            : strcpy(pszBuffer,"FORM_8_25_X_13"); break;
       case DeviceForm::FORM_170_X_210            : strcpy(pszBuffer,"FORM_170_X_210"); break;
       case DeviceForm::FORM_182_X_210            : strcpy(pszBuffer,"FORM_182_X_210"); break;
       case DeviceForm::FORM_ROLL_76_2MM          : strcpy(pszBuffer,"FORM_ROLL_76_2MM"); break;
       case DeviceForm::FORM_ROLL_69_5MM          : strcpy(pszBuffer,"FORM_ROLL_69_5MM"); break;

       default:
       {
          sprintf(pszBuffer, "w%dh%d", iCx, iCy);
          break;
       }
   }
}

char *
GetResolutionName (DeviceResolution *pDR)
{
   switch(pDR->getID())
   {
   case DeviceResolution::RESOLUTION_UNLISTED:                return "RESOLUTION_UNLISTED";
   case DeviceResolution::RESOLUTION_NONE:                    return "RESOLUTION_NONE";
   case DeviceResolution::RESOLUTION_60_X_60:                 return "RESOLUTION_60_X_60";
   case DeviceResolution::RESOLUTION_60_X_72:                 return "RESOLUTION_60_X_72";
   case DeviceResolution::RESOLUTION_60_X_180:                return "RESOLUTION_60_X_180";
   case DeviceResolution::RESOLUTION_60_X_360:                return "RESOLUTION_60_X_360";
   case DeviceResolution::RESOLUTION_72_X_72:                 return "RESOLUTION_72_X_72";
   case DeviceResolution::RESOLUTION_75_X_75:                 return "RESOLUTION_75_X_75";
   case DeviceResolution::RESOLUTION_80_X_60:                 return "RESOLUTION_80_X_60";
   case DeviceResolution::RESOLUTION_80_X_72:                 return "RESOLUTION_80_X_72";
   case DeviceResolution::RESOLUTION_90_X_180:                return "RESOLUTION_90_X_180";
   case DeviceResolution::RESOLUTION_90_X_360:                return "RESOLUTION_90_X_360";
   case DeviceResolution::RESOLUTION_90_X_60:                 return "RESOLUTION_90_X_60";
   case DeviceResolution::RESOLUTION_90_X_72:                 return "RESOLUTION_90_X_72";
   case DeviceResolution::RESOLUTION_90_X_90:                 return "RESOLUTION_90_X_90";
   case DeviceResolution::RESOLUTION_100_X_100:               return "RESOLUTION_100_X_100";
   case DeviceResolution::RESOLUTION_120_X_60:                return "RESOLUTION_120_X_60";
   case DeviceResolution::RESOLUTION_120_X_72:                return "RESOLUTION_120_X_72";
   case DeviceResolution::RESOLUTION_120_X_120:               return "RESOLUTION_120_X_120";
   case DeviceResolution::RESOLUTION_120_X_144:               return "RESOLUTION_120_X_144";
   case DeviceResolution::RESOLUTION_120_X_180:               return "RESOLUTION_120_X_180";
   case DeviceResolution::RESOLUTION_120_X_360:               return "RESOLUTION_120_X_360";
   case DeviceResolution::RESOLUTION_144_X_72:                return "RESOLUTION_144_X_72";
   case DeviceResolution::RESOLUTION_150_X_150:               return "RESOLUTION_150_X_150";
   case DeviceResolution::RESOLUTION_180_X_180:               return "RESOLUTION_180_X_180";
   case DeviceResolution::RESOLUTION_180_X_360:               return "RESOLUTION_180_X_360";
   case DeviceResolution::RESOLUTION_200_X_200:               return "RESOLUTION_200_X_200";
   case DeviceResolution::RESOLUTION_240_X_60:                return "RESOLUTION_240_X_60";
   case DeviceResolution::RESOLUTION_240_X_72:                return "RESOLUTION_240_X_72";
   case DeviceResolution::RESOLUTION_240_X_144:               return "RESOLUTION_240_X_144";
   case DeviceResolution::RESOLUTION_240_X_240:               return "RESOLUTION_240_X_240";
   case DeviceResolution::RESOLUTION_300_X_300:               return "RESOLUTION_300_X_300";
   case DeviceResolution::RESOLUTION_360_X_180:               return "RESOLUTION_360_X_180";
   case DeviceResolution::RESOLUTION_360_X_360:               return "RESOLUTION_360_X_360";
   case DeviceResolution::RESOLUTION_360_X_720:               return "RESOLUTION_360_X_720";
   case DeviceResolution::RESOLUTION_400_X_400:               return "RESOLUTION_400_X_400";
   case DeviceResolution::RESOLUTION_600_X_300:               return "RESOLUTION_600_X_300";
   case DeviceResolution::RESOLUTION_600_X_600:               return "RESOLUTION_600_X_600";
   case DeviceResolution::RESOLUTION_720_X_360:               return "RESOLUTION_720_X_360";
   case DeviceResolution::RESOLUTION_720_X_720:               return "RESOLUTION_720_X_720";
   case DeviceResolution::RESOLUTION_1200_X_600:              return "RESOLUTION_1200_X_600";
   case DeviceResolution::RESOLUTION_1200_X_1200:             return "RESOLUTION_1200_X_1200";
   case DeviceResolution::RESOLUTION_1440_X_720:              return "RESOLUTION_1440_X_720";
   case DeviceResolution::RESOLUTION_2880_X_720:              return "RESOLUTION_2880_X_720";
   case DeviceResolution::RESOLUTION_DRAFT:                   return "RESOLUTION_DRAFT";
   case DeviceResolution::RESOLUTION_FINE:                    return "RESOLUTION_FINE";
   case DeviceResolution::RESOLUTION_GROUP_3:                 return "RESOLUTION_GROUP_3";
   case DeviceResolution::RESOLUTION_GROUP_4:                 return "RESOLUTION_GROUP_4";
   case DeviceResolution::RESOLUTION_HIGH:                    return "RESOLUTION_HIGH";
   case DeviceResolution::RESOLUTION_LOW:                     return "RESOLUTION_LOW";
   case DeviceResolution::RESOLUTION_MEDIUM:                  return "RESOLUTION_MEDIUM";
   case DeviceResolution::RESOLUTION_NORMAL:                  return "RESOLUTION_NORMAL";
   case DeviceResolution::RESOLUTION_PHOTO_QUALITY:           return "RESOLUTION_PHOTO_QUALITY";
   case DeviceResolution::RESOLUTION_PRESENTATION:            return "RESOLUTION_PRESENTATION";
   default:                                                   return "";
   }
}

int
main (int argc, char *argv[])
{
   char              achLibDeviceName[512];
   char             *pszDeviceName;
   GModule          *hmodDevice            = 0;
   Device           *pDevice               = 0;
   PFNNEWDEVICE      pfnNewDevice          = 0;
   Enumeration      *pEnum                 = 0;
   DeviceForm       *pDF                   = 0;
   DeviceMedia      *pDM                   = 0;
   DeviceTray       *pDT                   = 0;
   DeviceResolution *pDR                   = 0;
   char             *pszDot                = 0;
   int               rc                    = 0;

   if (2 != argc)
   {
      cerr << "Usage: " << argv[0] << " printer_library_name" << endl;

      return 1;
   }

   Omni::initialize ();

   if (0 != strncasecmp (argv[1], "lib", 3))
   {
      sprintf (achLibDeviceName, "lib%s.so", argv[1]);
   }
   else
   {
      strcpy (achLibDeviceName, argv[1]);
   }

   cerr << "Trying to load " << achLibDeviceName << endl;

   if (!Omni::openDeviceLibrary (achLibDeviceName, &hmodDevice))
   {
      rc = 2;
      goto done;
   }

   g_module_symbol (hmodDevice, "newDeviceW_Advanced", (gpointer *)&pfnNewDevice);

   pszDeviceName = achLibDeviceName + 3; // Skip the lib part

   pszDot = strchr (pszDeviceName, '.');
   pszDot[0] = '\0';

   pDevice = pfnNewDevice (true);

   if (!pDevice)
   {
      cerr << "Could not instantiate a new device." << endl;

      g_module_close (hmodDevice);

      rc = 4;
      goto done;
   }

   cout << "*PPD-Adobe: \"4.3\"" << endl;
   cout << "*%PPD file for CUPS/Omni." << endl;
   cout << "*%This PPD file may be freely used and distributed under the terms of" << endl;
   cout << "*%the GNU LGPL." << endl;
   cout << "*FormatVersion:	\"4.3\"" << endl;
   cout << "*FileVersion:	\"" << pDevice->getVersion () << "\"" << endl;
   cout << "*LanguageVersion: English" << endl;
   cout << "*LanguageEncoding: ISOLatin1" << endl;
   cout << "*PCFileName:	\"" << pszDeviceName << ".ppd\"" << endl;
   cout << "*Manufacturer:	\"" << pDevice->getDriverName () << "\"" << endl;
   cout << "*Product:	\"(Omni v" << pDevice->getVersion () << ")\"" << endl;
   cout << "*ModelName:	\"" << pDevice->getDeviceName () << "\"" << endl;
// *ShortNickName @TBD
   cout << "*NickName:	\"lib" << pszDeviceName << ".so\"" << endl; // @TBD
   cout << "*PSVersion:	\"(3010.000) 550\"" << endl;
   cout << "*LanguageLevel:	\"3\"" << endl;

   if (pDevice->hasCapability (Capability::COLOR))
   {
      cout << "*ColorDevice:	True" << endl;
      cout << "*DefaultColorSpace:	RGB" << endl;
   }
   else
   {
      cout << "*ColorDevice:	False" << endl;
      cout << "*DefaultColorSpace:	Gray" << endl;
   }

   cout << "*FileSystem:	False" << endl;
   cout << "*LandscapeOrientation: Plus90" << endl;
   cout << "*TTRasterizer:	Type42" << endl;

   cout << "*cupsVersion:	1.1" << endl;
// *cupsModelNumber @TBD
   cout << "*cupsManualCopies: True" << endl;
   cout << "*cupsFilter:	\"application/vnd.cups-raster 100 CUPSToOmni\"" << endl;
// EPSON @TBD
// *cupsFilter:	\"application/vnd.cups-command 100 commandtoepson\"\n"); @TBD

   cout << endl;

   cout << "*OpenUI *PageSize/Media Size: PickOne" << endl;
   cout << "*OrderDependency: 10 AnySetup *PageSize" << endl;

   pDF   = pDevice->getCurrentForm ();
   pEnum = pDF->getEnumeration ();

   cout << "*DefaultPageSize: ";
   memset(pszBuffer, 0, bufsize);  //@@PAZ
   outputPostscriptName (pDF);
   cout << pszBuffer << endl;   //@@PAZ


   while (pEnum->hasMoreElements ())
   {

      pDF = (DeviceForm *)pEnum->nextElement ();

      HardCopyCap *pHCC = pDF->getHardCopyCap ();
      int          iCx;
      int          iCy;

      iCx = (int)(72.0 * (float)pHCC->getCx () / TMM_TO_INCHES);
      iCy = (int)(72.0 * (float)pHCC->getCy () / TMM_TO_INCHES);

      memset(pszBuffer, 0, bufsize-1);  //@@PAZ

      cout << "*PageSize ";

      outputPostscriptName (pDF);
      cout << pszBuffer ;
//      strcat(pszBuffer, "/");
//      strcat(pszBuffer, pDF->getName());
//      strcat(pszBuffer, ":");
//      memset(pszBuffer1, ' ', bufsize1-1);
//      pszBuffer1[bufsize1-1] = '\0';
//      memcpy(pszBuffer1, pszBuffer, strlen(pszBuffer));
//      cout << pszBuffer1;

//      cout << " \"<</PageSize["
//           << iCx
//           << " "
//           << iCy
//           << "]/ImagingBBox null>>setpagedevice\""
//           << endl;


      cout << "/"
           << pDF->getName ()
           << ":\t\"<</PageSize["
           << iCx
           << " "
           << iCy
           << "]/ImagingBBox null>>setpagedevice\""
           << endl;

      delete pDF;
   }

   cout << "*CloseUI: *PageSize" << endl;

   delete pEnum;

   cout << endl;

   cout << "*OpenUI *PageRegion: PickOne" << endl;
   cout << "*OrderDependency: 10 AnySetup *PageRegion" << endl;

   pDF   = pDevice->getCurrentForm ();
   pEnum = pDF->getEnumeration ();

   cout << "*DefaultPageRegion: ";

   memset(pszBuffer, 0, bufsize);

   outputPostscriptName (pDF);

   cout << pszBuffer << endl;

   while (pEnum->hasMoreElements ())
   {
      pDF = (DeviceForm *)pEnum->nextElement ();

      HardCopyCap *pHCC = pDF->getHardCopyCap ();
      int          iCx;
      int          iCy;

      iCx = (int)(72.0 * (float)pHCC->getCx () / TMM_TO_INCHES);
      iCy = (int)(72.0 * (float)pHCC->getCy () / TMM_TO_INCHES);

      memset(pszBuffer, 0, bufsize-1);  //@@PAZ

      cout << "*PageRegion ";

      outputPostscriptName (pDF);
      cout << pszBuffer ;

      cout << "/"
           << pDF->getName ()
           << ":\t\"<</PageRegion["
           << iCx
           << " "
           << iCy
           << "]/ImagingBBox null>>setpagedevice\""
           << endl;

      delete pDF;
   }

   cout << "*CloseUI: *PageRegion" << endl;

   delete pEnum;

   cout << endl;

   pDF   = pDevice->getCurrentForm ();
   pEnum = pDF->getEnumeration ();

   cout << "*DefaultImageableArea: ";
   memset(pszBuffer, 0, bufsize);
   outputPostscriptName (pDF);
   cout << pszBuffer << endl;

   while (pEnum->hasMoreElements ())
   {
      pDF = (DeviceForm *)pEnum->nextElement ();

      HardCopyCap *pHCC    = pDF->getHardCopyCap ();

      float          iCx     = 72.0 * (float)pHCC->getCx         () / TMM_TO_INCHES;
      float          iCy     = 72.0 * (float)pHCC->getCy         () / TMM_TO_INCHES;
      float          iLeft   = 72.0 * (float)pHCC->getLeftClip   () / TMM_TO_INCHES;
      float          iRight  = 72.0 * (float)pHCC->getRightClip  () / TMM_TO_INCHES;
      float          iTop    = 72.0 * (float)pHCC->getTopClip    () / TMM_TO_INCHES;
      float          iBottom = 72.0 * (float)pHCC->getBottomClip () / TMM_TO_INCHES;

      cout << "*ImageableArea ";
      memset(pszBuffer, 0, bufsize);
      outputPostscriptName (pDF);

      cout << pszBuffer;

      cout << "/"
           << pDF->getName ()
           << ":\t\""
           << iLeft
           << " "
           << iBottom
           << " "
           << iCx - iRight
           << " "
           << iCy - iTop
           << "\""
           << endl;

      delete pDF;
   }

   delete pEnum;

   cout << endl;

   pDF   = pDevice->getCurrentForm ();
   pEnum = pDF->getEnumeration ();

   cout << "*DefaultPaperDimension: ";
   memset(pszBuffer, 0, bufsize);
   outputPostscriptName (pDF);
   cout << pszBuffer << endl;

   while (pEnum->hasMoreElements ())
   {
      pDF = (DeviceForm *)pEnum->nextElement ();

      HardCopyCap *pHCC    = pDF->getHardCopyCap ();
      int          iCx     = (int)(72.0 * (float)pHCC->getCx () / TMM_TO_INCHES);
      int          iCy     = (int)(72.0 * (float)pHCC->getCy () / TMM_TO_INCHES);

      cout << "*PaperDimension ";
      memset(pszBuffer, 0, bufsize);
      outputPostscriptName (pDF);

      cout << pszBuffer;

      cout << "/"
           << pDF->getName ()
           << ":\t\""
           << iCx
           << " "
           << iCy
           << "\""
           << endl;

      delete pDF;
   }

   delete pEnum;

   cout << endl;

   cout << "*OpenUI *ColorModel: PickOne" << endl;
   cout << "*OrderDependency: 10 AnySetup *ColorModel" << endl;

   if (pDevice->hasCapability (Capability::COLOR))
   {
      cout << "*DefaultColorModel: RGB" << endl;
      cout << "*ColorModel Gray/Grayscale:\t\"<</cupsColorSpace "
           << (unsigned long int)CUPS_CSPACE_W
           << "/cupsColorOrder "
           << (unsigned long int)CUPS_ORDER_CHUNKED
           << "/cupsBitsPerColor 1>>setpagedevice\""
           << endl;
      cout << "*ColorModel RGB/Color:\t\"<</cupsColorSpace "
           << (unsigned long int)CUPS_CSPACE_RGB
           << "/cupsColorOrder "
           << (unsigned long int)CUPS_ORDER_CHUNKED
           << "/cupsBitsPerColor 8>>setpagedevice\"" // @TBD - shouldn't this be 24 bits per pel?
           << endl;
   }
   else
   {
      cout << "*DefaultColorModel: Gray" << endl;
      cout << "*ColorModel Gray/Grayscale:\t\"<</cupsColorSpace "
           << (unsigned long int)CUPS_CSPACE_W
           << "/cupsColorOrder "
           << (unsigned long int)CUPS_ORDER_CHUNKED
           << "/cupsBitsPerColor 1>>setpagedevice\""
           << endl;
   }

   cout << "*CloseUI: *ColorModel" << endl;

   cout << endl;

   cout << "*OpenUI *MediaType: PickOne" << endl;
   cout << "*OrderDependency: 10 AnySetup *MediaType" << endl;

   pDM = pDevice->getCurrentMedia ();

   cout << "*DefaultMediaType: " << DeviceMedia::IDToName (pDM->getID ()) << endl;

   pEnum = pDM->getEnumeration ();

   while (pEnum->hasMoreElements ())
   {
      pDM = (DeviceMedia *)pEnum->nextElement ();

      cout << "*MediaType "
           << DeviceMedia::IDToName (pDM->getID ())
           << "/"
           << pDM->getName ()
           << ":\t\"<</MediaType("
           << pDM->getName ()        // @TBD - should this be our settable name?
           << ")>>setpagedevice\""
           << endl;

      delete pDM;
   }

   cout << "*CloseUI: *MediaType" << endl;

   delete pEnum;

   cout << endl;

   cout << "*OpenUI *InputSlot: PickOne" << endl;
   cout << "*OrderDependency: 10 AnySetup *InputSlot" << endl;

   pDT = pDevice->getCurrentTray ();

   cout << "*DefaultInputSlot: " << DeviceTray::IDToName (pDT->getID ()) << endl;

   pEnum = pDT->getEnumeration ();

   while (pEnum->hasMoreElements ())
   {
      pDT = (DeviceTray *)pEnum->nextElement ();

      cout << "*InputSlot "
           << DeviceTray::IDToName (pDT->getID ())
           << "/"
           << pDT->getName ()
           << ":\t\"<</MediaClass("
           << pDT->getName ()        // @TBD - should this be our settable name?
           << ")>>setpagedevice\""
           << endl;

      delete pDT;
   }

   cout << "*CloseUI: *InputSlot" << endl;

   delete pEnum;

   cout << endl;

   cout << "*OpenUI *Dither: PickOne" << endl;
   cout << "*OrderDependency: 10 AnySetup *Dither" << endl;

   pEnum = DeviceDither::getEnumeration ();

   cout << "*DefaultDither: " << pDevice->getCurrentDitherID () << endl;

   while (pEnum->hasMoreElements ())
   {
      char *pszID = (char *)pEnum->nextElement ();

      cout << "*Dither "
           << pszID
           << "/"
           << DeviceDither::getName (pDevice,pszID)
           << ":\t\"<</OutputType("
           // @TBD - should this be our settable name?
           << DeviceDither::getName (pDevice,pszID)
           << ")>>setpagedevice\""
           << endl;
   }

   cout << "*CloseUI: *Dither" << endl;

   delete pEnum;

   cout << endl;

   cout << "*OpenUI *Resolution: PickOne" << endl;
   cout << "*OrderDependency: 20 AnySetup *Resolution" << endl;

   pDR = pDevice->getCurrentResolution ();

//   cout << "*DefaultResolution: " << DeviceResolution::IDToName (pDR->getID ()) << endl;

   cout << "*DefaultResolution: " << GetResolutionName(pDR) << endl;

   pEnum = pDR->getEnumeration ();

   while (pEnum->hasMoreElements ())
   {
      pDR = (DeviceResolution *)pEnum->nextElement ();

      cout << "*Resolution "
//           << DeviceResolution::IDToName (pDR->getID ())
           << GetResolutionName(pDR)
           << "/"
           << pDR->getName ()
           << ":\t\"<</HWResolution["
           << pDR->getXRes ()
           << " "
           << pDR->getYRes ()
           << "]/cupsCompression "
           << pDR->getID ()        // @TBD - correct?
           << ">>setpagedevice\""
           << endl;

      delete pDR;
   }

   cout << "*CloseUI: *Resolution" << endl;

   delete pEnum;

   cout << endl;

   cout << "*DefaultFont: Courier" << endl;
   cout << "*Font AvantGarde-Book: Standard \"(001.006S)\" Standard ROM" << endl;
   cout << "*Font AvantGarde-BookOblique: Standard \"(001.006S)\" Standard ROM" << endl;
   cout << "*Font AvantGarde-Demi: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font AvantGarde-DemiOblique: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font Bookman-Demi: Standard \"(001.004S)\" Standard ROM" << endl;
   cout << "*Font Bookman-DemiItalic: Standard \"(001.004S)\" Standard ROM" << endl;
   cout << "*Font Bookman-Light: Standard \"(001.004S)\" Standard ROM" << endl;
   cout << "*Font Bookman-LightItalic: Standard \"(001.004S)\" Standard ROM" << endl;
   cout << "*Font Courier: Standard \"(002.004S)\" Standard ROM" << endl;
   cout << "*Font Courier-Bold: Standard \"(002.004S)\" Standard ROM" << endl;
   cout << "*Font Courier-BoldOblique: Standard \"(002.004S)\" Standard ROM" << endl;
   cout << "*Font Courier-Oblique: Standard \"(002.004S)\" Standard ROM" << endl;
   cout << "*Font Helvetica: Standard \"(001.006S)\" Standard ROM" << endl;
   cout << "*Font Helvetica-Bold: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font Helvetica-BoldOblique: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font Helvetica-Narrow: Standard \"(001.006S)\" Standard ROM" << endl;
   cout << "*Font Helvetica-Narrow-Bold: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font Helvetica-Narrow-BoldOblique: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font Helvetica-Narrow-Oblique: Standard \"(001.006S)\" Standard ROM" << endl;
   cout << "*Font Helvetica-Oblique: Standard \"(001.006S)\" Standard ROM" << endl;
   cout << "*Font NewCenturySchlbk-Bold: Standard \"(001.009S)\" Standard ROM" << endl;
   cout << "*Font NewCenturySchlbk-BoldItalic: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font NewCenturySchlbk-Italic: Standard \"(001.006S)\" Standard ROM" << endl;
   cout << "*Font NewCenturySchlbk-Roman: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font Palatino-Bold: Standard \"(001.005S)\" Standard ROM" << endl;
   cout << "*Font Palatino-BoldItalic: Standard \"(001.005S)\" Standard ROM" << endl;
   cout << "*Font Palatino-Italic: Standard \"(001.005S)\" Standard ROM" << endl;
   cout << "*Font Palatino-Roman: Standard \"(001.005S)\" Standard ROM" << endl;
   cout << "*Font Symbol: Special \"(001.007S)\" Special ROM" << endl;
   cout << "*Font Times-Bold: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font Times-BoldItalic: Standard \"(001.009S)\" Standard ROM" << endl;
   cout << "*Font Times-Italic: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font Times-Roman: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font ZapfChancery-MediumItalic: Standard \"(001.007S)\" Standard ROM" << endl;
   cout << "*Font ZapfDingbats: Special \"(001.004S)\" Standard ROM" << endl;

   cout << "*%%End of " << pszDeviceName << ".ppd" << endl;

   delete pDevice;

   g_module_close (hmodDevice);

done:
   Omni::terminate ();

   return rc;
}
