/*
 *   IBM Omni driver
 *   Copyright (c) International Business Machines Corp., 2000
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License
 *   along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef _DebugOutput
#define _DebugOutput

#include <stdio.h>

using namespace std;

class DebugOutput
{
public:
   static ostream& getErrorStream                    ();
   static void     setErrorStream                    (FILE    *pFile);

   static void     applyAllDebugOutput               (char    *pszJobProperties);

   static void     setDebugOutput                    (char    *pszValue);

   static bool     shouldOutputDeviceBlitter         ();
   static bool     shouldOutputDeviceDither          ();
   static bool     shouldOutputDeviceInstance        ();
   static bool     shouldOutputDevicePrintMode       ();
   static bool     shouldOutputDeviceTester          ();
   static bool     shouldOutputGplCompression        ();
   static bool     shouldOutputGplDitherInstance     ();
   static bool     shouldOutputOmni                  ();
   static bool     shouldOutputOmniInterface         ();
   static bool     shouldOutputOmniProxy             ();
   static bool     shouldOutputPrintDevice           ();
   static bool     shouldOutputBlitter               ();
   static bool     shouldOutputInstance              ();
   static bool     shouldOutputOmniPDCProxy          ();
   static bool     shouldOutputOmniServer            ();
   static bool     shouldOutputPrinterCommand        ();
   static bool     shouldOutputPluggableInstance     ();
   static bool     shouldOutputPluggableBlitter      ();
   static bool     shouldOutputDriverInfo            ();
   static bool     shouldOutputPDCBlitter            ();
   static bool     shouldOutputPDCBlitterClient      ();
   static bool     shouldOutputDeviceString          ();
   static bool     shouldOutputUPDFDevice            ();
   static bool     shouldOutputUPDFDeviceOrientation ();
   static bool     shouldOutputUPDFDeviceForm        ();
   static bool     shouldOutputUPDFDeviceTray        ();
   static bool     shouldOutputUPDFDeviceMedia       ();
   static bool     shouldOutputUPDFDevicePrintMode   ();
   static bool     shouldOutputUPDFDeviceResolution  ();
   static bool     shouldOutputUPDFDeviceBooklet     ();
   static bool     shouldOutputUPDFDeviceCollation   ();
   static bool     shouldOutputUPDFDeviceCopies      ();
   static bool     shouldOutputUPDFDeviceDestination ();
   static bool     shouldOutputUPDFDeviceDuplex      ();
   static bool     shouldOutputUPDFDeviceJogging     ();
   static bool     shouldOutputUPDFDeviceNUp         ();
   static bool     shouldOutputUPDFDeviceScaling     ();
   static bool     shouldOutputUPDFDeviceStapling    ();
   static bool     shouldOutputUPDFDeviceInstance    ();
   static bool     shouldOutputUPDFDeviceBlitter     ();
   static bool     shouldOutputXMLDevice             ();
   static bool     shouldOutputXMLDeviceOrientation  ();
   static bool     shouldOutputXMLDeviceForm         ();
   static bool     shouldOutputXMLDeviceTray         ();
   static bool     shouldOutputXMLDeviceMedia        ();
   static bool     shouldOutputXMLDevicePrintMode    ();
   static bool     shouldOutputXMLDeviceResolution   ();
   static bool     shouldOutputXMLDeviceBooklet      ();
   static bool     shouldOutputXMLDeviceCollation    ();
   static bool     shouldOutputXMLDeviceCopies       ();
   static bool     shouldOutputXMLDeviceDestination  ();
   static bool     shouldOutputXMLDeviceDuplex       ();
   static bool     shouldOutputXMLDeviceJogging      ();
   static bool     shouldOutputXMLDeviceNUp          ();
   static bool     shouldOutputXMLDeviceScaling      ();
   static bool     shouldOutputXMLDeviceStapling     ();
   static bool     shouldOutputXMLDeviceInstance     ();
   static bool     shouldOutputXMLDeviceBlitter      ();

   static void     setOutputDeviceBlitter            (bool     fOutputDeviceBlitter);
   static void     setOutputDeviceDither             (bool     fOutputDeviceDither);
   static void     setOutputDeviceInstance           (bool     fOutputDeviceInstance);
   static void     setOutputDevicePrintMode          (bool     fOutputDevicePrintMode);
   static void     setOutputDeviceTester             (bool     fOutputDeviceTester);
   static void     setOutputGplCompression           (bool     fOutputGplCompression);
   static void     setOutputGplDitherInstance        (bool     fOutputGplDitherInstance);
   static void     setOutputOmni                     (bool     fOutputOmni);
   static void     setOutputOmniInterface            (bool     fOutputOmniInterface);
   static void     setOutputOmniProxy                (bool     fOutputOmniProxy);
   static void     setOutputPrintDevice              (bool     fOutputPrintDevice);
   static void     setOutputBlitter                  (bool     fOutputBlitter);
   static void     setOutputInstance                 (bool     fOutputInstance);
   static void     setOutputOmniPDCProxy             (bool     fOutputOmniPDCProxy);
   static void     setOutputOmniServer               (bool     fOutputOmniServer);
   static void     setOutputPrinterCommand           (bool     fOutputPrinterCommand);
   static void     setOutputPluggableInstance        (bool     fOutputPluggableInstance);
   static void     setOutputPluggableBlitter         (bool     fOutputPluggableBlitter);
   static void     setOutputDriverInfo               (bool     fOutputDriverInfo);
   static void     setOutputPDCBlitter               (bool     fOutputPDCBlitter);
   static void     setOutputPDCBlitterClient         (bool     fOutputPDCBlitterClient);
   static void     setOutputDeviceString             (bool     fOutputDeviceString);
   static void     setOutputUPDFDevice               (bool     fOutputUPDFDevice);
   static void     setOutputUPDFDeviceOrientation    (bool     fOutputUPDFDeviceOrientation);
   static void     setOutputUPDFDeviceForm           (bool     fOutputUPDFDeviceForm);
   static void     setOutputUPDFDeviceTray           (bool     fOutputUPDFDeviceTray);
   static void     setOutputUPDFDeviceMedia          (bool     fOutputUPDFDeviceMedia);
   static void     setOutputUPDFDevicePrintMode      (bool     fOutputUPDFDevicePrintMode);
   static void     setOutputUPDFDeviceResolution     (bool     fOutputUPDFDeviceResolution);
   static void     setOutputUPDFDeviceBooklet        (bool     fOutputUPDFDeviceBooklet);
   static void     setOutputUPDFDeviceCollation      (bool     fOutputUPDFDeviceCollation);
   static void     setOutputUPDFDeviceCopies         (bool     fOutputUPDFDeviceCopies);
   static void     setOutputUPDFDeviceDestination    (bool     fOutputUPDFDeviceDestination);
   static void     setOutputUPDFDeviceDuplex         (bool     fOutputUPDFDeviceDuplex);
   static void     setOutputUPDFDeviceJogging        (bool     fOutputUPDFDeviceJogging);
   static void     setOutputUPDFDeviceNUp            (bool     fOutputUPDFDeviceNUp);
   static void     setOutputUPDFDeviceScaling        (bool     fOutputUPDFDeviceScaling);
   static void     setOutputUPDFDeviceStapling       (bool     fOutputUPDFDeviceStapling);
   static void     setOutputUPDFDeviceInstance       (bool     fOutputUPDFDeviceInstance);
   static void     setOutputUPDFDeviceBlitter        (bool     fOutputUPDFDeviceBlitter);
   static void     setOutputXMLDevice                (bool     fOutputXMLDevice);
   static void     setOutputXMLDeviceOrientation     (bool     fOutputXMLDeviceOrientation);
   static void     setOutputXMLDeviceForm            (bool     fOutputXMLDeviceForm);
   static void     setOutputXMLDeviceTray            (bool     fOutputXMLDeviceTray);
   static void     setOutputXMLDeviceMedia           (bool     fOutputXMLDeviceMedia);
   static void     setOutputXMLDevicePrintMode       (bool     fOutputXMLDevicePrintMode);
   static void     setOutputXMLDeviceResolution      (bool     fOutputXMLDeviceResolution);
   static void     setOutputXMLDeviceBooklet         (bool     fOutputXMLDeviceBooklet);
   static void     setOutputXMLDeviceCollation       (bool     fOutputXMLDeviceCollation);
   static void     setOutputXMLDeviceCopies          (bool     fOutputXMLDeviceCopies);
   static void     setOutputXMLDeviceDestination     (bool     fOutputXMLDeviceDestination);
   static void     setOutputXMLDeviceDuplex          (bool     fOutputXMLDeviceDuplex);
   static void     setOutputXMLDeviceJogging         (bool     fOutputXMLDeviceJogging);
   static void     setOutputXMLDeviceNUp             (bool     fOutputXMLDeviceNUp);
   static void     setOutputXMLDeviceScaling         (bool     fOutputXMLDeviceScaling);
   static void     setOutputXMLDeviceStapling        (bool     fOutputXMLDeviceStapling);
   static void     setOutputXMLDeviceInstance        (bool     fOutputXMLDeviceInstance);
   static void     setOutputXMLDeviceBlitter         (bool     fOutputXMLDeviceBlitter);
};

#endif
