/*
 *   IBM Omni driver
 *   Copyright (c) International Business Machines Corp., 2000
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License
 *   along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#include "DeviceCommand.hpp"

DeviceCommand::
~DeviceCommand ()
{
   for ( CommandMap::iterator next = data_d.begin () ;
         next != data_d.end () ;
         next++ )
   {
//////cout << "Deleting " << (*next).first << " @ " << (*next).second << ", " << *(*next).second << endl;

      delete (*next).second;
      (*next).second = 0;
   }
}

char * DeviceCommand::
getName ()
{
   return "deviceCommand";
}

void DeviceCommand::
add (char *pszName, BinaryData *data)
{
   data_d[string (pszName)] = data;
}

BinaryData * DeviceCommand::
getCommandData (char *pszCommand)
{
   return data_d[string (pszCommand)];
}

string DeviceCommand::
toString (ostringstream& oss)
{
   oss << "{ 0x" << hex << (int)this << dec << "}";

   return oss.str ();
}

/* Provide a way to print out class data
*/
ostream&
operator<< (ostream& os, const DeviceCommand& const_self)
{
   DeviceCommand& self = const_cast<DeviceCommand&>(const_self);
   ostringstream  oss;

   os << self.toString (oss);

   return os;
}
