/*
 *   IBM Omni driver
 *   Copyright (c) International Business Machines Corp., 2002
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License
 *   along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "DeviceDestination.hpp"

DeviceDestination::
DeviceDestination (Device     *pDevice,
                   int         id,
                   BinaryData *pbdData)
{
   pDevice_d = pDevice;
   id_d      = id;
   pbdData_d = pbdData;
}

DeviceDestination::
~DeviceDestination ()
{
   pDevice_d = 0;
   id_d      = 0;
   pbdData_d = 0;
}

char * DeviceDestination::
getName ()
{
   return "";
}

bool DeviceDestination::
isID (int id)
{
   return id == id_d;
}

int DeviceDestination::
getID ()
{
   return id_d;
}

char * DeviceDestination::
getDeviceID ()
{
   return 0;
}

BinaryData * DeviceDestination::
getData ()
{
   return pbdData_d;
}

DeviceDestination * DeviceDestination::
create (char *pszId)
{
   return this->createV (nameToID (pszId));
}

int DeviceDestination::
nameToID (char *pszId)
{
   return -1;
}

char * DeviceDestination::
IDToName (int id)
{
   return 0;
}

string DeviceDestination::
toString (ostringstream& oss)
{
   oss << "{"
       << "}";

   return oss.str ();
}

/* Provide a way to print out class data
*/
ostream&
operator<< (ostream& os, const DeviceDestination& const_self)
{
   DeviceDestination& self = const_cast<DeviceDestination&>(const_self);
   ostringstream      oss;

   os << self.toString (oss);

   return os;
}
