/*
 *   IBM Omni driver
 *   Copyright (c) International Business Machines Corp., 2000
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License
 *   along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "Device.hpp"
#include "Omni.hpp"

#if 1

int
main (int argc, char *argv[])
{
   Omni::initialize ();

   Enumeration *pEnum = Omni::listDevices (true);

   while (pEnum->hasMoreElements ())
   {
      OmniDevice *pOD     = (OmniDevice *)pEnum->nextElement ();
      char       *pszName = "Error";

      if (pOD)
      {
         pszName = pOD->getLibraryName ();
      }

      cout << pszName << endl;

      delete pOD;
   }

   Omni::terminate ();

   return 0;
}

#endif

#if 0

int
main (int argc, char *argv[])
{
   Omni::initialize ();

   Enumeration *pEnum = DeviceDither::getEnumeration ();

   while (pEnum->hasMoreElements ())
   {
      char *pszName = (char *)pEnum->nextElement ();

      DebugOutput::getErrorStream () << pszName << endl;
   }

   delete pEnum;

   Omni::terminate ();

   return 0;
}

#endif

#if 0

int
main (int argc, char *argv[])
{
   Omni::initialize ();

   if (2 == argc)
   {
      extern bool ditherLibraryValid (char *pszName);

      ditherLibraryValid (argv[1]);
   }
   else
   {
      extern char *queryLibrary (char *pszFillIn, char *pszID);
      char achLine[512];

      queryLibrary (achLine, "DITHER_BOB");
   }

   Omni::terminate ();

   return 0;
}

#endif
