/*
 *   IBM Omni driver
 *   Copyright (c) International Business Machines Corp., 2002
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License
 *   along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef _COM_IBM_LINUX_OMNI_JOB_Driver
#define _COM_IBM_LINUX_OMNI_JOB_Driver

#include <vector>
#include <map>
#include <string>
#include <sstream>

class Driver;

#include "DriverProperty.hpp"

using namespace std;

class Driver
{
public:
                   Driver                    (string                   driverName,
                                              DriverProperty         **dpArr,
                                              int                      count);
                   Driver                    (string                   driverName,
                                              vector<DriverProperty>   dps);
                   Driver                    ();

   string          getName                   ();

   vector<string>  getAvailablePropertyNames ();
   DriverProperty  getProperty               (string                   key);
   bool            setProperty               (string                   key,
                                              DriverProperty           dpValue);

   string          toString                  (ostringstream&           oss);

protected:
   string                       driverName_d;
   vector<string>               availablePropertyNames_d;
   map<string, DriverProperty>  theMap_d;
};

#endif
