Summary: The Omni Print Driver Framework
Name: OmniPanasonic
Version: 0.7.2omni
Release: 4
Provides: Omni = %{version}-%{release}
License: LGPL
URL: http://oss.software.ibm.com/developer/opensource/linux/projects/omni/
Group: Applications/Publishing
Source0: http://prdownloads.sourceforge.net/omniprint/Omni-0.7.2.tar.gz

BuildRoot: %{_tmppath}/Omni-%{version}-root

%description
Omni provides support for many printers with a pluggable framework (easy
to add devices). Device data is defined with XML with many different hook
points for code support. Omni also supports many new printing standards.

%prep
%setup -q -n Omni

%build
	# Make the omni project
	./setupOmni DEVICES="Panasonic"

%install
	rm -rf $RPM_BUILD_ROOT
	mkdir -p $RPM_BUILD_ROOT

	make prefix=$RPM_BUILD_ROOT/opt/Omni \
		DEVICES="Panasonic" install

%clean
	rm -rf $RPM_BUILD_ROOT

%post
	# add /opt/Omni/lib to /etc/ld.so.conf
	if ! grep /opt/Omni/lib /etc/ld.so.conf >/dev/null 2>&1; then \
		/bin/cp /etc/ld.so.conf /etc/ld.so.conf.preomni; \
		echo /opt/Omni/lib >> /etc/ld.so.conf; \
		ldconfig; \
	fi
	# add omni.sh to /etc/profile.d
        if [ -d /etc/profile.d/ -a ! -f /etc/profile.d/omni.sh ]; then \
		echo "The PATH needs to be changed.  Please open a new shell."; \
		echo 'if ! echo $PATH | /bin/grep -q "/opt/Omni/bin" ; then' > /etc/profile.d/omni.sh; \
		echo '	PATH=$PATH:/opt/Omni/bin' >> /etc/profile.d/omni.sh; \
		echo 'fi' >> /etc/profile.d/omni.sh; \
	fi
	# add omni.csh to /etc/profile.d
        if [ -d /etc/profile.d/ -a ! -f /etc/profile.d/omni.csh ]; then \
                echo 'if ( `echo $PATH | grep /opt/Omni/bin`"a" == "a" ) then' > /etc/profile.d/omni.csh; \
		echo '	setenv PATH "${PATH}:/opt/Omni/bin"' >> /etc/profile.d/omni.csh; \
		echo 'endif' >> /etc/profile.d/omni.csh; \
	fi
	# check for old path
	if grep /opt/Omni/bin /etc/profile >/dev/null 2>&1; then \
		/bin/cp /etc/profile /etc/profile.postomni; \
		sed '/\/opt\/Omni\/bin/d' /etc/profile > /tmp/$$; \
		/bin/cp /tmp/$$ /etc/profile.conf; \
		/bin/rm /tmp/$$; \
	fi
	# check for old omni installation
	if [ -d /usr/lib/Omni ]; then \
		/bin/rm -rf /usr/lib/Omni; \
	fi
	# install foomatic support
	(	export PATH=/opt/Omni/bin:${PATH}; \
		if [ -d /usr/share/foomatic/db/source ]; then \
			OmniFoomaticGenerator -b /usr/share/foomatic/db/source; \
		fi;
	)
	# zap the cache
	rm -rf /var/cache/foomatic/{pcache,compiled}/*

%postun
	# remove /opt/Omni/lib to /etc/ld.so.conf
	if grep /opt/Omni/lib /etc/ld.so.conf >/dev/null 2>&1; then \
		/bin/cp /etc/ld.so.conf /etc/ld.so.conf.postomni; \
		sed '/\/opt\/Omni\/lib/d' /etc/ld.so.conf > /tmp/$$; \
		/bin/cp /tmp/$$ /etc/ld.so.conf; \
		/bin/rm /tmp/$$; \
		ldconfig; \
	fi
	# remove omni.sh from /etc/profile.d
        if [ -f /etc/profile.d/omni.sh ]; then \
		/bin/rm /etc/profile.d/omni.sh; \
	fi
	# remove omni.csh from /etc/profile.d
        if [ -f /etc/profile.d/omni.csh ]; then \
		/bin/rm /etc/profile.d/omni.csh; \
	fi
	# remove foomatic
        find /usr/share/foomatic/db/source -name \*omni\* -exec rm {} \;

%files
%defattr(-,root,root)
/opt/Omni/*

%changelog
* Mon Mar  4 2002 Mark Hamzy <hamzy@us.ibm.com>	0.6.1omni
- added support for Omni-0.6.1
- omni installs in /opt/Omni for LSB
- cache was misspelled

* Thu Oct 25 2001 Crutcher Dunnavant <crutcher@redhat.com> 0.5.0-4
- zap the foomatic cache on install

* Thu Oct 18 2001 Crutcher Dunnavant <crutcher@redhat.com> 0.5.0-2
- patch to make omni seek in /usr/lib/Omni and /opt/Omni/bin

* Mon Oct 15 2001 Crutcher Dunnavant <crutcher@redhat.com> 0.5.0-1
- initial packaging
